#ifndef _GAMEENGINE_H_
#define _GAMEENGINE_H_

#ifndef LINUX
#include "SDL.h"
#else
#include <SDL/SDL.h>
#endif

#include <vector>

#include "rgl.h"

// The engine for running the game
// Handling gamestates and everything

using namespace std;
class GameState;

class GameEngine
{
public: 

	GameEngine();
	~GameEngine();

	void init(const char* title, int width=800, int height=600, 
		      int bpp=32, bool fullscreen=false);
	void free();

	void changeState(GameState* state);

	void handleEvents();
	void update();
	void draw();

	bool running() { return run; }
	void quit() { run = false; }

	//SDL_Surface* screen;

	SDL_Event event;
	Timer clock;
	Textures tex;

private:

	// the stack of states
	GameState *states;

	int screen_width;
	int screen_height;
	int bpp;
	bool fullscreen;
	bool run;

};

#endif
