#ifndef _GAMESTATE_H_
#define _GAMESTATE_H_

// Upper class for all the gamestates used in game

#include "gameengine.h"
#include <string>

class GameEngine;

class GameState
{
protected:
	std::string statename;	// used for logging and such - allways initialize :)
public:

	GameState() { }
	~GameState() { 

	}

	virtual void init() = 0;
	virtual void free() = 0;

	virtual void pause() = 0;
	virtual void resume() = 0;

	virtual void handleEvents(GameEngine* game) = 0;
	virtual void update(GameEngine* game) = 0;
	virtual void draw(GameEngine* game) = 0;

	std::string getStateName() { return statename; }
};


#endif
