//////////////////////////////////////////////////////////////////////
// isochar.cpp: implementation of the isochar class.
//////////////////////////////////////////////////////////////////////

#include "isochar.h"

#include "math.h"

isochar::isochar()
{

	this->worldPos = Vector(200,150,0);
	this->last_anim_time = 0;
	this->facing = 1;
	this->anim_state = 0;
}

isochar::~isochar()
{

}


void isochar::draw(GameEngine *game) {

	// Find out what sprite to draw
	int to_draw_y = facing*2 + anim_state;

	int to_draw_x = to_draw_y % 8;
	int n = 0;
	while(to_draw_y>7) {
		n++;
		to_draw_y-=8;
	}
	to_draw_y=n;

	// Check if animation time has elapsed and advance animation
	if(game->clock.frametimelast > last_anim_time + anim_time) {
		
		this->anim_state++;
		if(this->anim_state>1) this->anim_state=0;

		this->facing++;
		if(this->facing>7) this->facing=0;


		this->last_anim_time = game->clock.frametimelast;
	}


		RBlit(RRect((int)this->worldPos.x,		(int)this->worldPos.y, 		64, 128), 
		game->tex.isochars,
		RRect(to_draw_x*64,to_draw_y*128,64,128));

}

void isochar::move(GameEngine *game) {

 
	this->worldPos.x += this->getDirectionX()*0.5f;
	this->worldPos.y += this->getDirectionY()*0.5f;
 	

}

int isochar::getDirectionX() {

	switch(facing) {
		case 0: 
			return 2;
		case 1: 
			return 1;
		case 2:
			return 0;
		case 3:
			return -1;
		case 4:
			return -2;
		case 5:
			return -1;
		case 6:
			return 0;
		case 7:
			return 1;
		default:
			return 0;	// Shouldn't happen
		break;
	}
}

int  isochar::getDirectionY() {
	switch(facing) {
		case 0: 
			return 0;
		case 1: 
			return -1;
		case 2:
			return -2;
		case 3:
			return -1;
		case 4:
			return 0;
		case 5:
			return 1;
		case 6:
			return 2;
		case 7:
			return 1;
		default:
			return 0;	// Shouldn't happen
		break;
	}
}


