#include <stdio.h>
#include "lista.h"

//#define LISTDEBUG

ListanSolmu::ListanSolmu()
{
}
ListanSolmu::~ListanSolmu()
{
}
ListanSolmu::ListanSolmu(void *ptr)
{
	payload = ptr;
}
void ListanSolmu::set(void *ptr)
{
	payload = ptr;
}
void ListanSolmu::print()
{

}
Lista::Lista()
{
	//nollataan kaikki osoittimet
	start = 0;
	current = 0;
	end = 0;
	//nollataan solmujen mr
	solmuja = 0;
#ifdef LISTDEBUG
	loki->writeToLog("Lista::Lista() : Lista luotu");
#endif
}
Lista::~Lista()
{
}

//listn alkio Listan loppuun
void Lista::add(void *dataptr)
{
	ListanSolmu *temp;
	solmuja++;

	if (start == 0) //listn Listaan ensimmist alkiota
	{
		//luodaan uusi solmu
		temp = new ListanSolmu(dataptr);

		//koska solmu on ensimminen, nm ovat molemmat 0
		temp->previous = 0;
		temp->next = 0;

		//molemmat "posoittimet" osoittamaan ekaan solmuun
		start = temp;
		end = temp;

#ifdef LISTDEBUG
		loki->writeToLog("Lista::add : Luotu ensimminen Listan solmu");
		temp->print();
#endif
	}
	else
	{
		//luodaan uusi solmu Listan perlle
		ListanSolmu *temp = new ListanSolmu(dataptr);
		//seuraavaa solmua ei tietenkn ole
		temp->next = 0; 

		//menee yhden askeleen lopun jlkeen. Muutetaan vanha Listan loppu osoittamaan thn solmuun
		temp->previous = end;
		end->next = temp;

		//uusi solmu on Listan viimeinen
		end = temp;		
#ifdef LISTDEBUG
		loki->writeToLog("Lista::add : Luotu uusi solmu Listaan");
		temp->print();
#endif
	}
}

//laitetaan uusi alkio tyosoittimen kohdalle
bool Lista::insert(void *dataptr)
{
	if (current==0)
	{
		return false; //tyosoitin ei ole kelvollinen, joten ei tehd mitn ja palautetaan false
	}
	//ollaan Listan lopussa
	if (current == end)
	{
		add(dataptr); //laitetaan Listan loppuun uusi alkio
		return true;
	}
	//lisminen onnistuu joka tapauksessa tst eteenpin, joten listn solmujen mr
	solmuja++;
	//ollaan Listan alussa tai keskell, joten luodaan uusi solmu
	ListanSolmu *temp = new ListanSolmu(dataptr); 
	//asetetaan uusi solmu osoittamaan seuraavaan solmuun
	temp->next = current->next;
	//seuraavan solmun previous osoittaa uuteen solmuun
	current->next->previous = temp; 
	//seuraava solmu hoideltu
	//uusi solmu tulee vliin, joten sen edellinen on nykyinen
	temp->previous = current;
	//lopulta sdetn currentin seuraavan osoitin uuteen
	current->next = temp; 

	//huh
	return true;
}


//poistetaan alkio typointterin kohdalla
bool Lista::remove()
{
	if (start == 0)	//Lista tyhj
	{
#ifdef LISTDEBUG
		loki->writeToLog("Lista::remove : ei ole mitn poistettavaa");
#endif
		return false; //ei ole mitn poistettavaa
	}
	if (start == end)		//vain yksi alkio Listassa (current == start)
	{
		solmuja--;
#ifdef LISTDEBUG
		loki->writeToLog("Lista::remove : vain yksi alkio Listassa");
#endif
		if (current->payload != 0)	//poistetaan lasti jos sit on
		{
			delete current->payload;
		}
		delete current; //tuhotaan solmu

		start = 0;
		end = 0;
		current = 0; //nollataan pointterit

		return true;
	}
	if (current == end)	//yritetn poistaa viimeist alkiota
	{
#ifdef LISTDEBUG
		loki->writeToLog("Lista::remove : poistetaan viimeinen alkio");
#endif
		removeLast();	//solmujen mr muutetaan tll
		return false;
	}
	if (current == start) //yritetn poistaa ensimmist alkiota
	{
		solmuja--;
#ifdef LISTDEBUG
		loki->writeToLog("Lista::remove : poistetaan ensimmist alkiota");
#endif
		ListanSolmu *temp = start->next;	//osoitetaan Listan toiseen alkioon
		temp->previous = 0;					//josta tehdn Listan ensimminen alkio
		if (start->payload != 0)
		{
			delete start->payload;
		}
		delete start; //poistetaan start-osoittimen osoittama alkio
		start = temp; //ja laitetaan se osoittamaan Listan toiseen alkioon, joka on nyt ensimminen
		current = temp; //current mys

		return true;
	}
	//erikoistapaukset ksitelty

	solmuja--;
	ListanSolmu *temp;
	if (current->next != 0)
		temp = current->next;
	else
		temp = current->previous;

	current->previous->next = current->next; //hyptn currentin ylitse
	current->next->previous = current->previous;

	if (current->payload != 0)
	{
		delete current->payload;
	}
	delete current;
	current = temp; //current on joko seuraava tai edellinen (jos seuraavaa ei ollut)
	return true;
}

//poistetaan Listan viimeinen alkio

bool Lista::removeLast()
{
	if (start == 0)
	{
#ifdef LISTDEBUG
		loki->writeToLog("Lista::removeLast : ei ole mitn poistettavaa");
#endif
		return false; //ei ole mitn poistettavaa
	}
	else
	{
		solmuja--;
		if (end->previous == 0) //jos Listassa on vain yksi alkio
		{
#ifdef LISTDEBUG
			loki->writeToLog("Lista::removeLast : vain yksi alkio");
#endif
			if (end->payload != 0) //jos Lista osoittaa johonkin
			{
				delete end->payload;
			}
			delete end;	//poistetaan viimeinen alkio
			end = 0;	//nollataan nm, muuten ne osoittavat jonnekin jota ei ole en olemassa
			start = 0;
			current = 0;
		}
		else		//poistetaan viimeinen alkio
		{
#ifdef LISTDEBUG
			loki->writeToLog("Lista::removeLast");
#endif
			//solmu, joka osoittaa edelliseen
			ListanSolmu *temp = end->previous;

			//tuhotaan viimeisen solmun lasti
			if (end->payload != 0)
			{
				delete end->payload;
			}
			//jos current osoittaa loppuun, vaihdetaan se osoittamaan uuteen loppuun (muuten ryskis)
			if (current == end)
			{
				current = current->previous;
			}
			delete end;
			end = temp;
			temp->next = 0;
		}
		return true; //poisto onnistui
	}
}


//tuhotaan koko Lista
void Lista::destroy()
{
	int temp = solmuja; //solmuja muuttuu removeLastissa, joten siksi tehdn siit kopio nyt
#ifdef LISTDEBUG
	loki->writeToLog("Lista::destroy");
#endif
	for (int i=0;i<temp;i++)
		removeLast();
}
bool Lista::goToStart()
{
	if (start!=0)
	{
#ifdef LISTDEBUG
		loki->writeToLog("Lista::goToStart() onnistui");
#endif
		current = start;	//Lista on olemassa
		return true;
	}
#ifdef LISTDEBUG
	loki->writeToLog("Lista::goToStart() eponnistui");
#endif
	current = 0;
	return false;
}
bool Lista::goToEnd()
{
	if (end!=0)
	{
#ifdef LISTDEBUG
		loki->writeToLog("Lista::goToEnd() onnistui");
#endif
		current = end;	//Lista on olemassa
		return true;
	}
#ifdef LISTDEBUG
	loki->writeToLog("Lista::goToStart() eponnistui");
#endif
	current = 0;
	return false;
}
bool Lista::goForward()
{
	if (current == end)
	{
#ifdef LISTDEBUG
		loki->writeToLog("Lista::goForward() yritti menn lopusta ylitse!");
#endif
		return false;
	}
	if (current->next!=0)
	{
#ifdef LISTDEBUG
		loki->writeToLog("Lista::goForward() onnistui");
#endif
		current = current->next;
		return true;
	}
#ifdef LISTDEBUG
	loki->writeToLog("Lista::goForward() eponnistui");
#endif
	return false;
}
bool Lista::goBackwards()
{
	if (current->previous!=0)
	{
#ifdef LISTDEBUG
		loki->writeToLog("Lista::goBackwards() onnistui");
#endif
		current = current->previous;
		return true;
	}
#ifdef LISTDEBUG
	loki->writeToLog("Lista::goBackwards() eponnistui");
#endif
	return false;
}

bool Lista::goToNode(int number)
{
	/* paskaa koodia! */
	bool value;
	goToStart();

	for (int i=0;i<number;i++)
	{
		value = goForward();
	}
	return value;
}
int Lista::getCurrentNodeNumber()
{
	/* paskaa koodia! */
	int i=0;
	ListanSolmu *walker = start;
	while (walker != current)
	{
		i++;
		walker = walker->next;
	}
	return i;

}


void *Lista::getFirst()
{
	return start->payload;
}
void *Lista::getLast()
{
	return end->payload;
}
void *Lista::getCurrent()
{
	return current->payload;
}
void Lista::setCurrent(void *ptr)
{
	if (current->payload) //tuhotaan vanha
	{
		delete current->payload;
	}
	current->payload = ptr; 
}
int Lista::getNodeCount()
{
	return solmuja;
}

bool Lista::isAtEnd()
{
	if (current == end)
		return true;
	else return false;
}

bool Lista::isAtStart()
{
	if (current == start)
		return true;
	else return false;
}

void Lista::print()
{
#ifdef LISTDEBUG
	loki->writeToLog("Lista::print");
#endif
	ListanSolmu *walker = start;
	if (walker == 0)
		return; //Listassa ei ole mitn
	while (walker!=0)
	{
		walker->print();
		walker = walker->next;
	}
}

