#ifndef _LISTA_H_
#define _LISTA_H_

class ListanSolmu
{
public:

	//muodostimet ja tuhoajat
	ListanSolmu();
	ListanSolmu(void *ptr);
	~ListanSolmu();

	//asettaa solmun datan halutuksi
	void set(void *ptr);

	//tulostaa tiedot
	void print();

	//osoittimet seuraaviin osiin
	class ListanSolmu *next;
	class ListanSolmu *previous;

	//data, jota solmu kantaa
	void *payload;

};

class Lista
{
public:
	Lista();
	~Lista();
	
	//listn Listan loppuun alkio (onnistuu aina)
	void add(void *dataptr);
	//poistetaan Listan viimeinen alkio (palauttaa false jos Lista on tyhj)
	bool removeLast();
	//listn typointterin jlkeen alkio (palauttaa false jos typointteri ei ole kelvollinen)
	bool insert(void *dataptr);
	//poistetaan alkio typointterin kohdalta
	bool remove();

	//tuhotaan koko Lista ja vapautetaan kaikki tiedot
	void destroy();

	//asettaa typointterin Listan alkuun (palauttaa false jos Lista on tyhj)
	bool goToStart();
	//asettaa typointterin Listan loppuun (palauttaa false jos Lista on tyhj)
	bool goToEnd();
	//liikuttaa typointteria eteenpin (palauttaa false jos Lista on loppu)
	bool goForward();
	//liikuttaa typointteria taaksepin (palauttaa false jos ollaan alussa)
	bool goBackwards();
	//menee haluttuun nodeen (palauttaa false jos ei onnistu)
	bool goToNode(int number); 

	//tutkii, ollaanko ekassa nodessa
	bool isAtEnd();
	//tutkii, ollaanko vikassa nodessa
	bool isAtStart();

	//antaa ensimmisen noden osoittaman tiedon
	void *getFirst();
	//antaa viimeisen noden osoittaman tiedon
	void *getLast();
	//antaa typointterin osoittaman tiedon
	void *getCurrent();
	//asettaa typointterin nodeen uuden tiedon (tuhoaa vanhan jos siell sellaista on)
	void setCurrent(void *ptr);
	//kertoo kuinka monta solmua Listassa on
	int getNodeCount();
	//kertoo nykyisen noden
	int getCurrentNodeNumber();

	//tulostetaan Lista lokiin (debug)
	void print();
private:
	int solmuja;
	ListanSolmu *start;
	ListanSolmu *current;
	ListanSolmu *end;

};

#endif

