#include <iostream>
#include <list>
#include <string>

#include "rgl.h"
#include "inc.h"
#include "soundsystem.h"

#include "gameengine.h"
#include "playstate.h"
#include "mapstate.h"

using namespace std;

SoundSystem sound = SoundSystem();

int main( int argc, char *argv[] ) {

	printf("----------------------------\n");
	printf("::. Starting game engine .::\n");
	printf("----------------------------\n");

	GameEngine *engine = new GameEngine();
	engine->init("moi",800, 600, 32, false);

    GameState *myState = new MapState();
	engine->changeState(myState);

	sound.playMusic(0);

	while(engine->running()) {

		RPreRender();

		engine->update();

		engine->draw();

		engine->handleEvents();

		SDL_GL_SwapBuffers();

	}

	engine->free();
	delete engine;

	printf("-----------------------------\n");
	printf("::. Shutting game engine  .::\n");
	printf("-----------------------------\n");

	return 0;
}

