#ifndef _MAPSTATE_H_
#define _MAPSTATE_H_

#include "gamestate.h"
#include "vector.h"
#include "lista.h"

class MapTile
{
public:

    int x, y;
    int type;

    bool active;
    bool visible;
    bool produces;

    int timeToProduction;
    Vector worldPos;

    void draw();
};

class MapUnit
{
public:
    int x, y;
    int type;
};

class MapState : public GameState
{
public:

	MapState();
	~MapState();

	virtual void init();					// initialize
	virtual void free();					// free resources

	virtual void pause();					// state is paused 
	virtual void resume();					// state resumed

	virtual void handleEvents(GameEngine* game);	// get input
	virtual void update(GameEngine* game);			// do physics
	virtual void draw(GameEngine* game);			// draw 

private:

    //monesko vuoro
    volatile int gameTurns;
    //miss kohdassa ollaan vuoroa
    volatile int gameTurnPosition;

    //monettako unittia ollaan siirtmss
    int currentUnit;
    //
    int currentUnitX;
    int currentUnitY;

    void beginTurn();
    void advanceTurn();
    void endTurn();

    //piirtojutut
    void drawTiles(); //piirt tiilet
    void drawUnits(); //piirt yksikt
    void drawTile(int tileX, int tileY); //piirt yksittisen tiilen
    void drawSelectedTile(); //piirt valitun tiilen ymprille hohdon
    void drawSelectedUnit(); //piirt aktiivisen unitin

    void activateTile(int tileX, int tileY);
    void initNextTile();
    bool setTile(int tileX, int tileY);
    void processTiles();

    bool clipCoordinates(int *tileX, int *tileY);

// -------------------------------------------------------------------- voe vittu
    int animationTimer;
    float animationValue;

    int gridResX;
    int gridResY;

    int selectedTileX;
    int selectedTileY;
    int nextTileType;

    int selectedUnit;

    Vector cameraPos;
    Vector cameraTarget;

    float gridSizeX;
    float gridSizeY;

    MapTile *grid;
    Lista *units;
    int unitcount;



};


#endif
