//////////////////////////////////////////////////////////////////////
// playstate.cpp: implementation of the playstate class.
//////////////////////////////////////////////////////////////////////

#include "playstate.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
PlayState::PlayState()
{
	this->statename = "PlayState";
	m = new isochar();
	
	locx=0; locy=0;
	locx2=0; locy2=0;
}

PlayState::~PlayState()
{
    	delete m;
}

void PlayState::init() {

	int x, y;

    printf("PlayState::init()\n");

    tilesizeX = 64;
    tilesizeY = 128;

    tilesX = 15;
    tilesY = 15;
	
    map = new IsoTile[tilesX*tilesY];

	// paljonko siirretn piirtokohtia
	const int baseoffset_x = tilesizeX/2;
	const int baseoffset_y = 17;

	int to_x = 0;
	int to_y = 0;		

    //loopataan ja initoidaan gridi
    for (y=0;y<tilesY;y++)
    {
		to_x = 0-y*baseoffset_x;
		to_y = 0+y*baseoffset_y;

        for (x=0;x<tilesX;x++)
        {

			to_x += baseoffset_x;
			to_y += baseoffset_y;
			//if(y%2!=0) to_x+=baseoffset_x/2.0f;

            map[x+y*tilesX].type	 = (y*x)%3;
            map[x+y*tilesX].worldPos = Vector(to_x, to_y, 0);
        }
    }

	map[0].type = 3;
	map[20].type = 3;


}

void PlayState::draw(GameEngine *game) {

	glLoadIdentity();
	

	gluLookAt(200,150,800-sin(game->clock.frametimelast/1000.0f)*100.0f,
				  200,150,0,

				  0,1,0);


//	glTranslatef(0,0,-500.0f);

	int x, y;
	for (y=tilesY-1;y>=0;y--)		// Piirtess lhdetn ylhlt
    {
        
		for (x=tilesX-1;x>=0;x--)		// Piirtess lhdetn ylhlt
        {
			map[x+y*tilesX].draw(game);
        }
    }

	
	m->move(game);
	m->draw(game);

	RBlit(RRect(
		(int)this->loc.x,
		(int)this->loc.y, 
		30, 30), 
		game->tex.layer1,
		RRect(64,0,64,128));


	RPrint(game->tex, locx,locy, "HERE!",0);
	RPrint(game->tex, locx2,locy2, "HERE2!",0);

	RPrint(game->tex, 10,30, "Isometric game state",0);

	char buffer [150];
	sprintf (buffer, "FPS (%d) | deltatime (%d)", (int)game->clock.framespersecond, (int)game->clock.deltatime);
	RPrint(game->tex, 10,470, buffer,0);



}
void PlayState::update(GameEngine *game) { 
}
void PlayState::handleEvents(GameEngine *game) {

	Vector tmp = Vector();	

		while ( SDL_PollEvent(&game->event) ) {
		switch (game->event.type) {
			case SDL_QUIT:
				game->quit();
			break;
			case SDL_JOYBALLMOTION:

			break;
			case SDL_JOYAXISMOTION:
					if( game->event.jaxis.axis == 0) 
					{

					}

					if( game->event.jaxis.axis == 1) 
					{
						// Up-Down movement code goes here 
					}
					
					// printf("Joystick Moved!, %d, %d\n", event.jaxis.axis, event.jaxis.value);
			break;
			case SDL_MOUSEBUTTONDOWN:

				// Haetaan hiiren koordinaatti
				loc = getMouseCoord(game->event.motion.x, game->event.motion.y, 0);
				

				break;
			case SDL_JOYBUTTONDOWN:
			
			break;
			case SDL_JOYBUTTONUP:
			break;
			case SDL_JOYHATMOTION:
				if(game->event.jhat.hat & SDL_HAT_CENTERED)
					;
				else if(game->event.jhat.hat & SDL_HAT_LEFT)
					;
				else if(game->event.jhat.hat & SDL_HAT_RIGHT)
					;
			break;
            case SDL_KEYDOWN:
                switch( game->event.key.keysym.sym ){
					case SDLK_RCTRL:
					case SDLK_UP:
						break;
                    case SDLK_DOWN:
						break;
					case SDLK_LEFT:
						break;
					case SDLK_RIGHT:
						break;
					case SDLK_RETURN:
						break;
					case SDLK_LSHIFT:
						break;
					case SDLK_1:
						break;
					case SDLK_LALT:
						break;
					case SDLK_LCTRL:
						break;
					case SDLK_ESCAPE:
						game->quit();
						break;
					default:
                        break;
				  }
	           break;
            case SDL_KEYUP:
                switch( game->event.key.keysym.sym ){
					case SDLK_RCTRL:	
					case SDLK_UP:
						break;
                    case SDLK_DOWN:
						break;
                    case SDLK_LEFT:
						break;
					case SDLK_RIGHT:
                        break;
                    case SDLK_RETURN:
						break;
					default:
                        break;
				  }
	           break;
			default:
				break;			
			}
		}

}
void PlayState::pause() {
}
void PlayState::resume() {
}
void PlayState::free() {
}


// ---------------
// Specific things
// ---------------

void PlayState::drawTiles() {



}
