#ifndef _PLAYSTATE_H_
#define _PLAYSTATE_H_

#include "gamestate.h"


#include "IsoTile.h"

#include "isochar.h"


#include "vector.h"

class PlayState : public GameState
{
public:

	PlayState();
	~PlayState();

	virtual void init();					// initialize
	virtual void free();					// free resources

	virtual void pause();					// state is paused 
	virtual void resume();					// state resumed

	virtual void handleEvents(GameEngine* game);	// get input
	virtual void update(GameEngine* game);			// do physics
	virtual void draw(GameEngine* game);			// draw 

protected:

    void drawTiles();

    int tilesizeX;
    int tilesizeY;

    Vector cameraPos;
    Vector cameraTarget;

    int tilesY;
    int tilesX;

    IsoTile *map;

	isochar *m;

	int locx, locy;
	int locx2, locy2;
	Vector loc;


};


#endif
