// Sprite.cpp: implementation of the Sprite class.
//
//////////////////////////////////////////////////////////////////////

#include "sprite.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Sprite::Sprite()
{

}

Sprite::Sprite(float x, float y, int xs, int ys) {
		this->visible = true;
		this->x = x;
		this->y = y;
		this->size_x = xs;
		this->size_y = ys;
}

Sprite::~Sprite()
{

}


// Piirt spriten - jos se mahtuu ruuudulle
void Sprite::paint(Textures &tex, int cam_x, int cam_y) {

	if(
	  this->getX()+this->getXsize()-cam_x>0 
	  && this->getX()-cam_x<SCR_W 
	  && this->getY()+this->getYsize()-cam_y>0 
	  && this->getY()-cam_y<SCR_H
	  ) {

		RRect from(0,0,this->size_x, this->size_y);
		RRect to(this->getX(),this->getY(), this->size_x, this->size_y);
		RBlit(to,tex.items, from);
	}
}

int Sprite::getX()			{ return (int)this->x; }
int Sprite::getY()			{ return (int)this->y; }
int Sprite::getXsize()		{ return this->size_x; }
int Sprite::getYsize()		{ return this->size_y; }
int Sprite::getCenterX()	{ return (int)this->x+(this->size_x/2); }
int Sprite::getCenterY()	{ return (int)this->y+(this->size_y/2); }
void Sprite::setX(float x)	{ this->x=x; }
void Sprite::setY(float y)	{ this->y=y; }


 // Check collision for 2 objects
 //  True: collision 
 //  False: no collision 
bool Sprite::checkCollision(Sprite *o) {
  
    float left1, left2, right1, right2, top1, top2, bottom1, bottom2;
    
	left1	= (float)this->getX();
    left2	= (float)o->getX();
    right1	= left1 + o->getXsize();
    right2	= left2 + o->getXsize() ;
    top1	= (float)this->getY();
    top2	= (float)o->getY();
    bottom1 = top1 + this->getYsize();
    bottom2 = top2 + o->getYsize();

    if (bottom1 < top2) return false;
    if (top1 > bottom2) return false;
    if (right1 < left2) return false;
    if (left1 > right2) return false;

    return true;

};

bool Sprite::isvisible() {
	if(this->visible==false) 
		return false;
	else 
		return true;
}

bool Sprite::fitsInRect(int x, int y, int w, int h) {

	if(	this->getX()+this->getXsize()-x>0 
	    && this->getX()-x<w 
	    && this->getY()+this->getYsize()-y>0 
	    && this->getY()-y<h) 

		return true;
	else
		return false;
}
