
#ifndef _SPRITE_H_
#define _SPRITE_H_

#include "SDL.h"

#include "inc.h"
#include "rgl.h"

class Sprite  
{
public:
	Sprite();
	Sprite(float x, float y, int xs, int ys);
	virtual ~Sprite();
	virtual void paint(Textures &tex, int cam_x, int cam_y);
	int getX();
	int getY();
	int getXsize();
	int getYsize();
	int getCenterX();
	int getCenterY();
	float getSpeedX();
	float getSpeedY();
	void setX(float x);
	void setY(float y);
	bool fitsInRect(int x, int y, int w, int h);
	bool isvisible(); 
	bool checkCollision(Sprite *o);
	Uint32 getpixel(SDL_Surface *surface, int x, int y);
	virtual void move(float delta) {  };
	float x, y;	// sijainti & liikkumisnopeudet

protected:	
	
	bool visible, alive;					// blitataanko sprite
	int size_x, size_y;				// kuvan koko

};

#endif

